<template>
  <div class="user-page" v-if="user">
    <NavBar>
      <template slot="left">
        <nuxt-link
          v-if="user"
          :to="`/users/${user.username}`"
          style="margin-right: 20px"
          class="navbar__profile"
        >
          <Avatar :user="user" :size="50" />
        </nuxt-link>
        <div class="navbar__ul">
          <ul>
            <li>
              <nuxt-link :to="`/users/${user.username}`"> Portfolio </nuxt-link>
            </li>
            <li>
              <nuxt-link :to="`/users/${user.username}/events`">
                Events
              </nuxt-link>
            </li>
            <!-- <li>
              <nuxt-link :to="`/users/${user.username}/places`">
                Places
              </nuxt-link>
            </li> -->
            <li>
              <nuxt-link :to="`/users/${user.username}/store`">
                Store
              </nuxt-link>
            </li>
          </ul>
        </div>
      </template>
      <template slot="right">
        <div>
          <div
            class="navbar__links"
            @click="modals.share = !modals.share"
            v-wave
          >
            <svg-icon name="share" />
          </div>
        </div>
        <!-- <div>
          <div class="navbar__links" v-wave>
            <svg-icon name="like" />
          </div>
        </div> -->
        <!-- <div>
          <Button size="inline">Book event</Button>
        </div> -->
      </template>
    </NavBar>
    <div style="max-width: 1920px; margin: 0 auto; padding: 0 15px">
      <transition name="page-slide">
        <nuxt-child :data="user" />
      </transition>
    </div>
    <portal to="modal">
      <Modal v-model="modals.share">
        <template slot="title">{{ $t('share_link') }}</template>
        <ShareModal :url="`users/${user.username}`" />
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  useAsync,
  computed,
  ref
} from '@nuxtjs/composition-api'
import NavBar from '@/components/app/NavBar.vue'
import Avatar from '@/components/ui/Avatar.vue'
import Button from '@/components/ui/Button.vue'
import Modal from '@/components/ui/Modal.vue'
import ShareModal from '@/components/modal/ShareModal.vue'
import { useGetProfileQuery } from '~/sdk/hooks'

export default defineComponent({
  name: 'UserPage',
  layout: 'single',
  components: {
    NavBar,
    Avatar,
    Button,
    Modal,
    ShareModal
  },
  setup(_, { root }) {
    const { route, error } = useContext()
    const currentUser = computed(() => root.$accessor.auth.user)
    const username = route.value.params.username as string
    const modals = ref({
      share: false
    })
    const { onResult, loading } = useGetProfileQuery(
      { username: username },
      { fetchPolicy: 'network-only' }
    )
    const user = useAsync<any>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.user?.[0]) {
              error({ statusCode: 404 })
              return resolve()
            }
            const user = result.data.user[0]
            resolve(user)
          })
        )
    )

    return { currentUser, user, modals }
  }
})
</script>

<style lang="scss" scoped>
.user-page {
  padding: 80px 0 30px 0;
  @media (min-width: 991.98px) {
    padding: 160px 0 85px 0;
  }
  &-nav {
    display: flex;
    align-items: center;
    justify-content: flex-end;
  }
}
</style>
